#!/bin/sh

ITERATIONS=$1
shift
LOG=$1
shift
CMD=$@

VMLINUX=vmlinux
BIN=sched_latency_lkml

echo $ITERATIONS
echo $LOG
echo $CMD

date > $LOG
for ((i=0;i<$ITERATIONS;i++)); do
	echo -------------------- >> $LOG
	echo "ITERATION $i" >> $LOG
	echo -------------------- >> $LOG
	opcontrol --reset
	opcontrol --vmlinux=$VMLINUX
	opcontrol --start
	if ! $CMD > $LOG; then
		echo "$i: FAILED"
		opreport -l $BIN > $i-$BIN-profile-FAILED.txt
		opreport -l $VMLINUX > $i-vmlinux-profile-FAILED.txt
	else
		echo "$i: PASSED"
		opreport -l $BIN > $i-$BIN-profile-PASSED.txt
		opreport -l $VMLINUX > $i-vmlinux-profile-PASSED.txt
	fi
done
echo -------------------- >> $LOG
echo TEST COMPLETED >> $LOG
date >> $LOG
